> For the complete documentation index, see [llms.txt](https://docs.ionos.com/cloud/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.ionos.com/cloud/network-services/cdn/api-how-tos/retrieve-all-distributions.md).

# Retrieve All Distributions

{% hint style="info" %}
**Prerequisite:** Only contract administrators, owners, and users with `accessAndManageCdn` privilege can create and manage CDN distributions via the API. You can also set user privileges in the DCD. For more information, see [<mark style="color:blue;">Set User Privileges</mark>](/cloud/network-services/cdn/dcd-how-tos/set-user-privileges-cdn-dcd.md).
{% endhint %}

To retrieve all the CDN distributions under a contract, perform a `GET` request.

## Endpoint

Use the following endpoint to retrieve all CDN distributions for a contract: `https://cdn.de-fra.ionos.com/distributions`.

## Request

```bash
curl --location \
--request GET 'https://cdn.de-fra.ionos.com/distributions?offset=0&limit=100' \
--header 'Authorization: Bearer eyJ0eXAiOiJKV1QiLCJraWQiO' \
--header 'Content-Type: application/json'
```

{% tabs %}
{% tab title="Request Header Parameters" %}
To make authenticated requests to the API, the following fields are mandatory in the request header:

| **Header Parameters** | **Required** | **Type** | **Description**                                                                                                                                                                                                                                                                 |
| --------------------- | ------------ | -------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `Authorization`       | yes          | string   | The Bearer token enables requests to authenticate using a JSON Web Token (JWT). From the DCD, [<mark style="color:blue;">Generate authentication token</mark>](/cloud/set-up-ionos-cloud/management/identity-access-management/token-manager.md#generate-authentication-token). |
| `Content-Type`        | yes          | string   | Set this to `application/json`.                                                                                                                                                                                                                                                 |
| {% endtab %}          |              |          |                                                                                                                                                                                                                                                                                 |
| {% endtabs %}         |              |          |                                                                                                                                                                                                                                                                                 |

## Response

**200 Successful operation**

```bash
{
  "id": "24c578a9-361f-54d4-a326-a3f3070d5a03",
  "type": "collection",
  "href": "/distributions",
  "items": [
    {
      "id": "9ba15778-16c4-543c-8775-e52acf4853f5",
      "type": "distribution",
      "href": "/distributions/9ba15778-16c4-543c-8775-e52acf4853f5",
      "metadata": {
        "createdDate": "2020-12-10T13:37:50+01:00",
        "createdBy": "ionos:identity:::users/87f9a82e-b28d-49ed-9d04-fba2c0459cd3",
        "createdByUserId": "87f9a82e-b28d-49ed-9d04-fba2c0459cd3",
        "lastModifiedDate": "2020-12-11T13:37:50+01:00",
        "lastModifiedBy": "ionos:identity:::users/87f9a82e-b28d-49ed-9d04-fba2c0459cd3",
        "lastModifiedByUserId": "87f9a82e-b28d-49ed-9d04-fba2c0459cd3",
        "resourceURN": "ionos:<product>:<location>:<contract>:<resource-path>",
        "publicEndpointIpv4": "1.2.3.4",
        "publicEndpointIpv6": "2001:db8::ff00:42:8329",
        "state": "AVAILABLE",
        "message": "In progress."
      },
      "properties": {
        "domain": "example.com",
        "certificateId": "5a029f4a-72e5-11ec-90d6-0242ac120003",
        "routingRules": [
          {
            "scheme": "http/https",
            "prefix": "/api",
            "upstream": {
              "host": "server.example.com",
              "caching": true,
              "waf": true,
              "geoRestrictions": {
                "blockList": [
                  "CN",
                  "RU"
                ]
              },
              "rateLimitClass": "R100",
              "sniMode": "origin"
            }
          }
        ]
      }
    }
  ],
  "offset": 0,
  "limit": 42,
  "_links": {
    "prev": "http://PREVIOUS-PAGE-URI",
    "self": "http://THIS-PAGE-URI",
    "next": "http://NEXT-PAGE-URI"
  }
}
```

{% hint style="success" %}
**Result:** All the existing CDN distributions and their details are successfully obtained for your contract.
{% endhint %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.ionos.com/cloud/network-services/cdn/api-how-tos/retrieve-all-distributions.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
